<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';

import {
  CaseStudyContentArea,
  CaseStudyHero,
  CaseStudyPricingPlans,
  CaseStudyStickySidebar,
  CaseStudyCustomerSuccessStories,
} from '~/components/customers/index.vue';
import { NextStep } from '~/components/common/index.vue';

import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CaseStudyContentArea,
    CaseStudyHero,
    CaseStudyPricingPlans,
    CaseStudyStickySidebar,
    CaseStudyCustomerSuccessStories,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData({ params, error }: any) {
    try {
      const entries = await getClient().getEntries({
        content_type: CONTENT_TYPES.CASE_STUDY,
        'fields.slug': params.slug,
      });

      const [data] = entries.items;

      const baseDataCall = await getClient().getEntry('2YUEuoVflhGaUySCB3I7Lp');
      const baseData = baseDataCall.fields.schema;

      const metadata = {
        title: data.fields.companyName,
        description: data.fields.introduction,
        og_title: data.fields.companyName,
        og_image: data.fields.headerImage,
        og_description: data.fields.introduction,
        twitter_image: data.fields.headerImage,
        twitter_description: data.fields.introduction,
      };

      return { data, baseData, metadata };
    } catch (e) {
      return error({ statusCode: 404 });
    }
  },
  head(): MetaInfo {
    if (this.metadata) {
      return getPageMetadata((this as any).metadata, this.$route.path);
    }
    return getPageMetadata((this as any).data, this.$route.path);
  },
});
</script>

<template>
  <div>
    <CaseStudyHero :data="data.fields" :base-data="baseData" />

    <section>
      <SlpContainer class="slp-flex">
        <CaseStudyStickySidebar :data="data.fields" :base-data="baseData" />
        <CaseStudyContentArea :data="data.fields" :base-data="baseData" />
      </SlpContainer>
    </section>

    <CaseStudyPricingPlans :base-data="baseData" />

    <CaseStudyCustomerSuccessStories :base-data="baseData" />

    <section class="slp-mt-96">
      <SlpContainer variant="gradient">
        <NextStep :variant="data.fields.nextSteps.fields.variant" />
      </SlpContainer>
    </section>
  </div>
</template>
